/* Sparc64 gmp-mparam.h -- Compiler/machine parameter header file.

Copyright 1991, 1993, 1994, 1999, 2000, 2001 Free Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with the GNU MP Library; see the file COPYING.LIB.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA 02111-1307, USA. */

#define BITS_PER_MP_LIMB 64
#define BYTES_PER_MP_LIMB 8

/* Tell the toom3 multiply implementation to call low-level mpn
   functions instead of open-coding operations in C.  */
#ifndef USE_MORE_MPN
#define USE_MORE_MPN 1
#endif


/* 296MHz ultrasparc-II */

/* Generated by tuneup.c, 2001-11-29, Sun C 5.0 */

#define KARATSUBA_MUL_THRESHOLD       10
#define TOOM3_MUL_THRESHOLD           41

#define BASECASE_SQR_THRESHOLD         4
#define KARATSUBA_SQR_THRESHOLD       26
#define TOOM3_SQR_THRESHOLD           66

#define SB_PREINV_THRESHOLD            7
#define DC_THRESHOLD                  46
#define POWM_THRESHOLD                71

#define GCD_ACCEL_THRESHOLD            3
#define GCDEXT_THRESHOLD           MP_SIZE_T_MAX

#define DIVREM_1_NORM_THRESHOLD        5
#define DIVREM_1_UNNORM_THRESHOLD      5
#define MOD_1_NORM_THRESHOLD           4
#define MOD_1_UNNORM_THRESHOLD         5
#define USE_PREINV_MOD_1               0
#define DIVREM_2_THRESHOLD             8
#define DIVEXACT_1_THRESHOLD           0
#define MODEXACT_1_ODD_THRESHOLD       0

#define FFT_MUL_TABLE  { 272, 672, 1344, 2304, 5120, 12288, 0 }
#define FFT_MODF_MUL_THRESHOLD       200
#define FFT_MUL_THRESHOLD           1408

#define FFT_SQR_TABLE  { 272, 608, 1472, 2304, 7168, 20480, 49152, 0 }
#define FFT_MODF_SQR_THRESHOLD       232
#define FFT_SQR_THRESHOLD           1408
